# Jean-Franois Roche (jfroche@jfroche.be)
# ZPhotoSlides 0.8
# GNU GPL
# 


import os, sys, string
import PIL.Image
from PIL import ImageFont
from PIL import ImageDraw
from PIL import ImageOps
from PIL import ImageChops
from PIL import ImageEnhance
from PIL import ImageFilter
import traceback
import shutil

default_textpos = 'b' # t=top, b=bottom;  
default_textalign = 'l' # l=left, c=center, r=right;
textcolor_default = 0xff0000

class Image_modif:
	def __init__(self, path):
		## PIL Fonts : http://effbot.org/pil/pilfonts.zip ##
		fullpath = os.path.abspath(os.path.normpath(path))
                self.imgpath = fullpath
                try:
                        self.im = PIL.Image.open(self.imgpath)
                except:
			print traceback.print_exc()				
#                        sys.exit("Error : not a valid image file")
		self.imgname = os.path.basename(self.imgpath)
                self.basepath = os.path.dirname(self.imgpath)
                self.imgformat = self.im.format         # JPEG, GIF, ...
                self.imgmode = self.im.mode    
		self.rotname = self.imgname
		
	def make_backup(self):
                outputdir = self.basepath
                self.default = os.path.join(self.basepath,self.rotname)
		backup = self.default + '.bak'
                try: # make a backup of the old photo before rotation
			shutil.copyfile(self.default,backup)
			
		except IOError, e:
                        return "Error on file %s : %s" % (self.imgpath,e)
        def save_to(self,location):
		try: # make a backup of the old photo before rotation
			self.im.save(location)
		except:
			return "eh merde"
	def get_info(self):
		format = self.im.format
		mode = self.im.mode
		size = self.im.size
		info = self.im.info
		dict = {'format': format,'mode': mode,'height':size[1],'width':size[0]}
		return dict

	def save_modif(self):
		try:
                        self.im.save(self.default)
                except IOError, e:
                        return "Error on file %s : %s" % (self.imgpath,e)
	def getrotate(self,angle):
                """rotate a photo with a given angle"""
                angle = int(angle)
		self.im = self.im.rotate(angle)

	def gettextcopyright(self, textcopy, textpos, textalign, width, height, textfont, textsize, textboldfont=0, textitalicfont=0, textcolor='#FF0000'):
		"""Florent Carlier V0.1 - copyright a photo with a given text

	        boldfont:   0 ... normal font (the default)
                	    1 ... bold font

	        textpos:    The position of the copyright text can be specified by a string
        	            containing a combination of one characters.  One character
                	    must be either t ,b or m.

		textalign:  The Alignemnt of the copyright text can be specified by a string
        	            containing a combination of one characters.  One character
                	    must be either l, c or r.

                    t ... top
                    b ... bottom
		    m ... middle

                    l ... left
                    c ... center
                    r ... right

                    The default value is 'bl'

		"""
		img = self.im
		textfont = string.replace(textfont, "S", textsize)
		if textboldfont == '1':
			if textitalicfont == '1':
				boldfont = string.replace(textfont, "T", 'BI')
			else:
				boldfont = string.replace(textfont, "T", 'B')
			font = ImageFont.load_path(boldfont)
		elif textitalicfont == '1':
		    italicfont = string.replace(textfont, "T", 'I')
		    font = ImageFont.load_path(italicfont)
		else:
		    normalfont = string.replace(textfont, "T", 'R')
		    font = ImageFont.load_path(normalfont)
		tw, th = font.getsize(textcopy)
		tw -= 2
		th -= 2
		if 't' in textpos:
		    y = -1
		elif 'b' in textpos:
		    y = height - th - 2
		elif 'm' in textpos:
		    y = (height/2) - th - 2
		else:
		    raise ValueError, "textpos must contain exactly one out of 't', 'm', 'b'"
		if 'l' in textalign:
		    x = 2
		elif 'c' in textalign:
		    x = (width - tw) / 2
		elif 'r' in textalign:
		    x = (width - tw) - 2
		else:
		    raise ValueError, "textalign must contain exactly one out of 'l', 'c', 'r'"
		draw = ImageDraw.Draw(img)
		textcol = self.hex_to_rbg(textcolor)
		draw.text((x,y), text=textcopy, font=font, fill=textcol)
		del draw

	def change_Brightness(self,brightness):
		"""Change the Brightness of an image  0.0 -> 1.0"""
		print "brightness:"
		print brightness
		self.im = ImageEnhance.Brightness(self.im).enhance(brightness)
		
	def change_contrast(self,contrast):
		"""Change the contrast of an image  0.0 -> 1.0"""
		self.im = ImageEnhance.Contrast(self.im).enhance(contrast)
		
	def auto_contrast(self):
		"""Normalize image contrast"""
		self.im =  ImageOps.autocontrast(self.im)
		
	def equalize(self):
		"""Equalize the image histogram."""
		self.im = ImageOps.equalize(self.im)
		
	def add_borders(self,border=0,fill='#FFFFFF'):
		"""Add border pixels of border to the image fill color is HTML hex"""
		self.im = ImageOps.expand(self.im, border, self.hex_to_rbg(fill))
		
	def crop_image(self,border):
		"""Remove border from image. The same amount of pixels are removed from all four sides."""
		self.im = ImageOps.crop(self.im,border)
		
	def change_Sharpness(self,sharpness):
		"""Change the Sharpness of an image  0.0 -> 2.0 """
		self.im = ImageEnhance.Sharpness(self.im).enhance(sharpness)
		
	def change_Color(self,color):
		"""Change the Color of an image  0.0 -> 1.0 """
		self.im = ImageEnhance.Color(self.im).enhance(color)
		
	def filter_blur(self):
		"""Filter blur """
		self.im = self.im.filter(ImageFilter.BLUR)
		
	def filter_contour(self):
		"""Filter contour """
		self.im = self.im.filter(ImageFilter.CONTOUR)
		
	def filter_detail(self):
		"""Filter detail """
		self.im = self.im.filter(ImageFilter.DETAIL)
	def filter_enhance(self):
		"""Filter enhance """
		self.im = self.im.filter(ImageFilter.EDGE_ENHANCE)
	def filter_emboss(self):
		"""Filter emboss """
		self.im = self.im.filter(ImageFilter.EMBOSS)
	def filter_find_edges(self):
		"""Filter find_edges """
		self.im = self.im.filter(ImageFilter.FIND_EDGES)
	def filter_smooth(self):
		"""Filter smooth """
		self.im = self.im.filter(ImageFilter.SMOOTH)
	def filter_sharpen(self):
		"""Filter sharpen """
		self.im = self.im.filter(ImageFilter.SHARPEN)
	def transpose_left_right(self):
		"""Transpose left to right"""
		self.im = ImageOps.mirror(self.im)
	def invert_image(self):
		"""Invert an image"""
		self.im = ImageChops.invert(self.im)
	def solarize(self,threshold):
		self.im = ImageOps.solarize(self.im, threshold=128)
		
	#	, DETAIL, EDGE_ENHANCE, EDGE_ENHANCE_MORE, EMBOSS, FIND_EDGES,
	#SMOOTH, SMOOTH_MORE, and SHARPEN.

	def hex_to_rbg(self,string):
	    a = int(string[1],16)
            b = int(string[2],16)
            c = int(string[3],16)
            d = int(string[4],16)
            e = int(string[5],16)
            f = int(string[6],16)

            x = (a * 16) + b;
            y = (c * 16) + d;
            z = (e * 16) + f;
            tuple = (x,y,z)
	    return tuple
	
	def resize_image(self,height,width,ratio):
		assert height!=0.0,  'Height is 0! Impossible!'
		assert width!=0.0, 'Width is 0! Impossible!'	
		photo_size = (width,height)
 		self.im = self.im.resize(photo_size)
		return self.im

	def remove_color(self):
		self.im = self.im.convert('L')

if __name__ == "__main__":
#	a = Image_modif('c:\img\Bv112_02.jpg')
	print os.curdir
#	a.get_info()
#	a.make_backup()
#	print hex()
#	a.hex_to_int('#FFFFFF')
#	a.resize_image(200,500)
#	a.remove_color()
#	a.auto_contrast()
#	a.save_modif()
